SystemOrganization addCategory: #'DAO-TP-Changes-Server'!

Object subclass: #MutexParaGemstone
	instanceVariableNames: 'owner semaphore'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes-Server'!

!MutexParaGemstone methodsFor: 'as yet unclassified' stamp: 'SebaServer 12/7/2013 16:14'!
critical: aBlock
	"Evaluate aBlock protected by the receiver."
	| activeProcess |
	activeProcess := Processor activeProcess.
	activeProcess == owner ifTrue:[^aBlock value].
	^semaphore critical:[
		owner := activeProcess.
		aBlock ensure:[owner := nil]]. ! !

!MutexParaGemstone methodsFor: 'as yet unclassified' stamp: 'SebaServer 12/7/2013 16:14'!
initialize
	super initialize.
	semaphore := Semaphore forMutualExclusion.! !

Object subclass: #SistemaDeCambiosInterfazTCP_Server
	instanceVariableNames: 'connectionSocket isRunning isRunningLock listenPort sistemaDeCambios'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes-Server'!

!SistemaDeCambiosInterfazTCP_Server class methodsFor: 'as yet unclassified' stamp: 'SebaServer 12/4/2013 02:12'!
listenOn: aPort for: aSistemaDeCambios
	aPort isInteger
		ifTrue: [ 
			^self new initializeWith: aPort and: aSistemaDeCambios.
		]
		ifFalse: [ 
			Exception new signal: 'Puerto invlido'.
		]
 
	! !

!SistemaDeCambiosInterfazTCP_Server methodsFor: 'as yet unclassified' stamp: 'Seba 12/8/2013 02:03'!
decodificar: aByteString 
^
	(NeoJSONReader on: aByteString readStream)
		for: DateAndTime customDo: [ :mapping |
			mapping decoder: [ :string | DateAndTime fromString: string ].
			mapping encoder: [ :dateAndTime | dateAndTime printString ]
		];
		next.
! !

!SistemaDeCambiosInterfazTCP_Server methodsFor: 'as yet unclassified' stamp: 'Seba 12/8/2013 02:20'!
decodificarFecha: aByteString 
^	DateAndTime fromString: aByteString.! !

!SistemaDeCambiosInterfazTCP_Server methodsFor: 'as yet unclassified' stamp: 'Seba 12/8/2013 02:06'!
decodificarMensaje: diccionario
^
	(Message selector: (diccionario at: 'selector') asSymbol arguments: (diccionario at: 'args'))
		lookupClass: self class;
		yourself.
! !

!SistemaDeCambiosInterfazTCP_Server methodsFor: 'as yet unclassified' stamp: 'Seba 12/8/2013 19:50'!
handle: aByteString 
| dic anAuthor aClock intEntrada |
	dic := self decodificar: aByteString.
	(dic keys asSet = self validSet) ifTrue:[
		"aMessage := self decodificarMensaje: (dic at: 'm')."
		anAuthor := dic at: 'a'.
		aClock := self decodificarFecha: (dic at: 'c').
		intEntrada := InterfazDeEntradaDelSistemaDeCambios remotoWith: sistemaDeCambios andThisAuthor: anAuthor andThisClock: aClock.
		"aMessage sendTo: intEntrada."
		intEntrada perform: ((dic at: 'm') at: 'selector') asSymbol withArguments: ((dic at: 'm') at:'args').
	]
	ifFalse:[
		Exception new signal: 'Comando Invlido'.
	]! !

!SistemaDeCambiosInterfazTCP_Server methodsFor: 'as yet unclassified' stamp: 'SebaServer 12/7/2013 16:12'!
initialize
	super initialize.
	isRunningLock := MutexParaGemstone new.
	self isRunning: false.
	listenPort := 9999.
	sistemaDeCambios := SistemaDeCambios new.! !

!SistemaDeCambiosInterfazTCP_Server methodsFor: 'as yet unclassified' stamp: 'SebaServer 12/4/2013 00:44'!
initializeWith: aPort and: aSistemaDeCambios 
	listenPort := aPort.
	sistemaDeCambios := aSistemaDeCambios.! !

!SistemaDeCambiosInterfazTCP_Server methodsFor: 'as yet unclassified' stamp: 'Seba 12/8/2013 18:17'!
interactOnConnection 
	| interactionSocket |
	"interactionSocket := connectionSocket waitForAcceptFor: 1 ifTimedOut: [^self]."
	interactionSocket := connectionSocket accept.
	[self interactUsing: interactionSocket] fork.! !

!SistemaDeCambiosInterfazTCP_Server methodsFor: 'as yet unclassified' stamp: 'Seba 12/8/2013 18:16'!
interactUsing: interactionSocket
	[
		"interactionStream :=  SocketStream on: interactionSocket.
		self handle: interactionStream nextLine crLog.
		interactionStream sendCommand: 'Recibido Ok ;-P'."
		self isRunning ifTrue:[
			self handle: (interactionSocket read: 1024) asString.
		].
		interactionSocket write: 'Recibido Ok ;-P' asByteString.
	] ensure: [
		interactionSocket close.
	]! !

!SistemaDeCambiosInterfazTCP_Server methodsFor: 'as yet unclassified' stamp: 'SebaServer 12/2/2013 21:22'!
isRunning
	^isRunningLock critical: [ isRunning ].! !

!SistemaDeCambiosInterfazTCP_Server methodsFor: 'as yet unclassified' stamp: 'SebaServer 12/2/2013 21:23'!
isRunning: aBoolean
	^isRunningLock critical: [ isRunning := aBoolean ].! !

!SistemaDeCambiosInterfazTCP_Server methodsFor: 'as yet unclassified' stamp: 'Seba 12/8/2013 18:16'!
serve
	[
		[ self isRunning ]
			whileTrue: [ self interactOnConnection ] ]
	ensure: [
		"connectionSocket closeAndDestroy"
		connectionSocket close.
	]! !

!SistemaDeCambiosInterfazTCP_Server methodsFor: 'as yet unclassified' stamp: 'Seba 12/8/2013 18:17'!
start
	isRunningLock critical: [
		self isRunning ifTrue: [ ^ self ].
		self isRunning: true].
	"connectionSocket := Socket newTCP."
	"connectionSocket listenOn: listenPort backlogSize: 10."
	connectionSocket := SpSocket newTCPSocket.
	connectionSocket
		setAddressReuse: true;
		bindSocketAddress: (SpIPAddress hostName: 'localhost' port: listenPort);
		listenBackloggingUpTo: 50.	
	[ self serve ] fork.! !

!SistemaDeCambiosInterfazTCP_Server methodsFor: 'as yet unclassified' stamp: 'Seba 12/8/2013 19:00'!
stop
	| socket |
	isRunning ifTrue: [ 
		isRunning := false.
		socket := SpSocket connectToServerOnHost: 'localhost' port: listenPort.
		socket close.
	].

		! !

!SistemaDeCambiosInterfazTCP_Server methodsFor: 'as yet unclassified' stamp: 'Seba 12/8/2013 19:34'!
validSet
	^Set new
		add: 'm';
		add: 'a';
		add: 'c';
		yourself! !

TestCase subclass: #SDCITCPS_Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes-Server'!

!SDCITCPS_Test methodsFor: 'as yet unclassified' stamp: 'Seba 12/8/2013 01:41'!
mandameUnSms: aPort
	| ss |
	"ss := SocketStream openConnectionToHostNamed: '127.0.0.1' port: aPort."
	ss := SpSocket connectToServerOnHost: 'localhost' port: aPort .
	[
		ss write: '{"m":{"args":["Nombre-De-Categoria"],"selector":"classCategoryCreated:"},"a":"Seba","c":"2013-12-04T00:51:54.334-03:00"}'.
	] ensure: [ ss close ]
	! !

!SDCITCPS_Test methodsFor: 'as yet unclassified' stamp: 'Seba 12/8/2013 18:21'!
test01
| unSistemaDeCambios unServer aPort |
	[
		aPort := 9901.
		unSistemaDeCambios := SistemaDeCambios new.
		unServer := SistemaDeCambiosInterfazTCP_Server listenOn: aPort for: unSistemaDeCambios.
		unServer start.
		self assert:(unSistemaDeCambios todosLosCambios isEmpty).
		self mandameUnSms: aPort.
		(Delay forSeconds: 5) wait.
		self assert: (unSistemaDeCambios todosLosCambios size > 0).		
	] ensure: [ unServer stop ]! !
